"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Literal

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild
from githubkit.typing import Missing
from githubkit.utils import UNSET


class ServerStatisticsItems(GitHubModel):
    """ServerStatisticsItems"""

    server_id: Missing[str] = Field(default=UNSET)
    collection_date: Missing[str] = Field(default=UNSET)
    schema_version: Missing[str] = Field(default=UNSET)
    ghes_version: Missing[str] = Field(default=UNSET)
    host_name: Missing[str] = Field(default=UNSET)
    github_connect: Missing[ServerStatisticsItemsPropGithubConnect] = Field(
        default=UNSET
    )
    ghe_stats: Missing[ServerStatisticsItemsPropGheStats] = Field(default=UNSET)
    dormant_users: Missing[ServerStatisticsItemsPropDormantUsers] = Field(default=UNSET)
    actions_stats: Missing[ServerStatisticsActions] = Field(
        default=UNSET,
        description="Actions metrics that are included in the Server Statistics payload/export from GHES",
    )
    packages_stats: Missing[ServerStatisticsPackages] = Field(
        default=UNSET,
        description="Packages metrics that are included in the Server Statistics payload/export from GHES",
    )


class ServerStatisticsActions(GitHubModel):
    """ServerStatisticsActions

    Actions metrics that are included in the Server Statistics payload/export from
    GHES
    """

    number_of_repos_using_actions: Missing[int] = Field(
        default=UNSET,
        description="The total number of repositories in a GHES installation that have Actions enabled",
    )
    percentage_of_repos_using_actions: Missing[str] = Field(
        default=UNSET,
        description="The percentage of repositories in a GHES installation that have Actions enabled",
    )


class ServerStatisticsItemsPropGithubConnect(GitHubModel):
    """ServerStatisticsItemsPropGithubConnect"""

    features_enabled: Missing[list[str]] = Field(default=UNSET)


class ServerStatisticsItemsPropDormantUsers(GitHubModel):
    """ServerStatisticsItemsPropDormantUsers"""

    total_dormant_users: Missing[int] = Field(default=UNSET)
    dormancy_threshold: Missing[str] = Field(default=UNSET)


class ServerStatisticsPackages(GitHubModel):
    """ServerStatisticsPackages

    Packages metrics that are included in the Server Statistics payload/export from
    GHES
    """

    registry_enabled: Missing[bool] = Field(
        default=UNSET,
        description="Whether GitHub Packages is enabled globally in a GHES installation",
    )
    registry_v2_enabled: Missing[bool] = Field(
        default=UNSET,
        description="Whether a beta registry is enabled in a GHES installation",
    )
    ecosystems: Missing[list[ServerStatisticsPackagesPropEcosystemsItems]] = Field(
        default=UNSET,
        description="The details of the package ecosystems that are enabled in a GHES installation",
    )


class ServerStatisticsPackagesPropEcosystemsItems(GitHubModel):
    """ServerStatisticsPackagesPropEcosystemsItems"""

    name: Missing[
        Literal["npm", "maven", "docker", "nuget", "rubygems", "containers"]
    ] = Field(default=UNSET, description="The name of the package ecosystem")
    enabled: Missing[Literal["TRUE", "FALSE", "READONLY"]] = Field(
        default=UNSET,
        description="Shows if a package system is enabled, disabled, or read-only in a GHES installation",
    )
    published_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of published packages in a package ecosystem in a GHES installation",
    )
    private_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of private packages in a package ecosystem in a GHES installation",
    )
    public_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of public packages in a package ecosystem in a GHES installation",
    )
    internal_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of internal packages in a package ecosystem in a GHES installation",
    )
    user_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of user packages in a package ecosystem in a GHES installation",
    )
    organization_packages_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of organization packages in a package ecosystem in a GHES installation",
    )
    daily_download_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of packages in an ecosystem that have been downloaded in the 24 hours prior to `collection_date` for a GHES installation",
    )
    daily_update_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of packages in an ecosystem that have been updated in the 24 hours prior to `collection_date` for a GHES installation",
    )
    daily_delete_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of packages in an ecosystem that have been deleted in the 24 hours prior to `collection_date` for a GHES installation",
    )
    daily_create_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of packages in an ecosystem that have been created in the 24 hours prior to `collection_date` for a GHES installation",
    )


class ServerStatisticsItemsPropGheStats(GitHubModel):
    """ServerStatisticsItemsPropGheStats"""

    comments: Missing[ServerStatisticsItemsPropGheStatsPropComments] = Field(
        default=UNSET
    )
    gists: Missing[ServerStatisticsItemsPropGheStatsPropGists] = Field(default=UNSET)
    hooks: Missing[ServerStatisticsItemsPropGheStatsPropHooks] = Field(default=UNSET)
    issues: Missing[ServerStatisticsItemsPropGheStatsPropIssues] = Field(default=UNSET)
    milestones: Missing[ServerStatisticsItemsPropGheStatsPropMilestones] = Field(
        default=UNSET
    )
    orgs: Missing[ServerStatisticsItemsPropGheStatsPropOrgs] = Field(default=UNSET)
    pages: Missing[ServerStatisticsItemsPropGheStatsPropPages] = Field(default=UNSET)
    pulls: Missing[ServerStatisticsItemsPropGheStatsPropPulls] = Field(default=UNSET)
    repos: Missing[ServerStatisticsItemsPropGheStatsPropRepos] = Field(default=UNSET)
    users: Missing[ServerStatisticsItemsPropGheStatsPropUsers] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropComments(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropComments"""

    total_commit_comments: Missing[int] = Field(default=UNSET)
    total_gist_comments: Missing[int] = Field(default=UNSET)
    total_issue_comments: Missing[int] = Field(default=UNSET)
    total_pull_request_comments: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropGists(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropGists"""

    total_gists: Missing[int] = Field(default=UNSET)
    private_gists: Missing[int] = Field(default=UNSET)
    public_gists: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropHooks(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropHooks"""

    total_hooks: Missing[int] = Field(default=UNSET)
    active_hooks: Missing[int] = Field(default=UNSET)
    inactive_hooks: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropIssues(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropIssues"""

    total_issues: Missing[int] = Field(default=UNSET)
    open_issues: Missing[int] = Field(default=UNSET)
    closed_issues: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropMilestones(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropMilestones"""

    total_milestones: Missing[int] = Field(default=UNSET)
    open_milestones: Missing[int] = Field(default=UNSET)
    closed_milestones: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropOrgs(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropOrgs"""

    total_orgs: Missing[int] = Field(default=UNSET)
    disabled_orgs: Missing[int] = Field(default=UNSET)
    total_teams: Missing[int] = Field(default=UNSET)
    total_team_members: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropPages(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropPages"""

    total_pages: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropPulls(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropPulls"""

    total_pulls: Missing[int] = Field(default=UNSET)
    merged_pulls: Missing[int] = Field(default=UNSET)
    mergeable_pulls: Missing[int] = Field(default=UNSET)
    unmergeable_pulls: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropRepos(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropRepos"""

    total_repos: Missing[int] = Field(default=UNSET)
    root_repos: Missing[int] = Field(default=UNSET)
    fork_repos: Missing[int] = Field(default=UNSET)
    org_repos: Missing[int] = Field(default=UNSET)
    total_pushes: Missing[int] = Field(default=UNSET)
    total_wikis: Missing[int] = Field(default=UNSET)


class ServerStatisticsItemsPropGheStatsPropUsers(GitHubModel):
    """ServerStatisticsItemsPropGheStatsPropUsers"""

    total_users: Missing[int] = Field(default=UNSET)
    admin_users: Missing[int] = Field(default=UNSET)
    suspended_users: Missing[int] = Field(default=UNSET)


model_rebuild(ServerStatisticsItems)
model_rebuild(ServerStatisticsActions)
model_rebuild(ServerStatisticsItemsPropGithubConnect)
model_rebuild(ServerStatisticsItemsPropDormantUsers)
model_rebuild(ServerStatisticsPackages)
model_rebuild(ServerStatisticsPackagesPropEcosystemsItems)
model_rebuild(ServerStatisticsItemsPropGheStats)
model_rebuild(ServerStatisticsItemsPropGheStatsPropComments)
model_rebuild(ServerStatisticsItemsPropGheStatsPropGists)
model_rebuild(ServerStatisticsItemsPropGheStatsPropHooks)
model_rebuild(ServerStatisticsItemsPropGheStatsPropIssues)
model_rebuild(ServerStatisticsItemsPropGheStatsPropMilestones)
model_rebuild(ServerStatisticsItemsPropGheStatsPropOrgs)
model_rebuild(ServerStatisticsItemsPropGheStatsPropPages)
model_rebuild(ServerStatisticsItemsPropGheStatsPropPulls)
model_rebuild(ServerStatisticsItemsPropGheStatsPropRepos)
model_rebuild(ServerStatisticsItemsPropGheStatsPropUsers)

__all__ = (
    "ServerStatisticsActions",
    "ServerStatisticsItems",
    "ServerStatisticsItemsPropDormantUsers",
    "ServerStatisticsItemsPropGheStats",
    "ServerStatisticsItemsPropGheStatsPropComments",
    "ServerStatisticsItemsPropGheStatsPropGists",
    "ServerStatisticsItemsPropGheStatsPropHooks",
    "ServerStatisticsItemsPropGheStatsPropIssues",
    "ServerStatisticsItemsPropGheStatsPropMilestones",
    "ServerStatisticsItemsPropGheStatsPropOrgs",
    "ServerStatisticsItemsPropGheStatsPropPages",
    "ServerStatisticsItemsPropGheStatsPropPulls",
    "ServerStatisticsItemsPropGheStatsPropRepos",
    "ServerStatisticsItemsPropGheStatsPropUsers",
    "ServerStatisticsItemsPropGithubConnect",
    "ServerStatisticsPackages",
    "ServerStatisticsPackagesPropEcosystemsItems",
)
