"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import Union

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild
from githubkit.typing import Missing
from githubkit.utils import UNSET


class SecretScanningScanHistory(GitHubModel):
    """SecretScanningScanHistory"""

    incremental_scans: Missing[list[SecretScanningScan]] = Field(default=UNSET)
    pattern_update_scans: Missing[list[SecretScanningScan]] = Field(default=UNSET)
    backfill_scans: Missing[list[SecretScanningScan]] = Field(default=UNSET)
    custom_pattern_backfill_scans: Missing[
        list[SecretScanningScanHistoryPropCustomPatternBackfillScansItems]
    ] = Field(default=UNSET)


class SecretScanningScan(GitHubModel):
    """SecretScanningScan

    Information on a single scan performed by secret scanning on the repository
    """

    type: Missing[str] = Field(default=UNSET, description="The type of scan")
    status: Missing[str] = Field(
        default=UNSET,
        description='The state of the scan. Either "completed", "running", or "pending"',
    )
    completed_at: Missing[Union[datetime, None]] = Field(
        default=UNSET,
        description="The time that the scan was completed. Empty if the scan is running",
    )
    started_at: Missing[Union[datetime, None]] = Field(
        default=UNSET,
        description="The time that the scan was started. Empty if the scan is pending",
    )


class SecretScanningScanHistoryPropCustomPatternBackfillScansItems(GitHubModel):
    """SecretScanningScanHistoryPropCustomPatternBackfillScansItems"""

    type: Missing[str] = Field(default=UNSET, description="The type of scan")
    status: Missing[str] = Field(
        default=UNSET,
        description='The state of the scan. Either "completed", "running", or "pending"',
    )
    completed_at: Missing[Union[datetime, None]] = Field(
        default=UNSET,
        description="The time that the scan was completed. Empty if the scan is running",
    )
    started_at: Missing[Union[datetime, None]] = Field(
        default=UNSET,
        description="The time that the scan was started. Empty if the scan is pending",
    )
    pattern_name: Missing[str] = Field(
        default=UNSET, description="Name of the custom pattern for custom pattern scans"
    )
    pattern_scope: Missing[str] = Field(
        default=UNSET,
        description='Level at which the custom pattern is defined, one of "repository", "organization", or "enterprise"',
    )


model_rebuild(SecretScanningScanHistory)
model_rebuild(SecretScanningScan)
model_rebuild(SecretScanningScanHistoryPropCustomPatternBackfillScansItems)

__all__ = (
    "SecretScanningScan",
    "SecretScanningScanHistory",
    "SecretScanningScanHistoryPropCustomPatternBackfillScansItems",
)
